//filename:JokoCave.java

//version for NOKS40

//Copyright (C) 2002 Zindell Technologies, Ltd.
//All rights reserved. No part of the contents of this program may be
//reproduced or transmitted in any openingForm or by any means without the
//written permission of the publisher.

import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Gauge;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;

public class JokoCave extends MIDlet implements CommandListener
{
	static final boolean REAL_DEVICE = false;
	static final boolean DEBUG = true;
	
	Display display;
	Displayable currentDisplayable, previousDisplayable;

	private Form loadingForm, helpForm, aboutForm;
	Form resultForm;
	
	private SplashCanvas splashCanvas;
    MainCanvas mainCanvas;	
	private JokoCaveCanvas jokoCaveCanvas;
	private Thread thread;
	static Gauge gauge;

	private boolean firstTime;

	private Command solveCommand;
	private Command exitCommand;
	Command backCommand;

    private byte level=1;
    public static int highScore = 0;

	final String APP_VERSION = "version "+getAppProperty("MIDlet-Version");
	final String APP_NAME = getAppProperty("MIDlet-Name");
	String APP_SALE = getAppProperty("APP-SALE");
	final String APP_SPLASH = "/JokoCaveSplash.png";
	final String APP_MENU = "/JokoCaveMenu.png";	
	final String MAIN_STR = getAppProperty("MIDlet-Description");
	
	final String ABOUT_STR = "Joko Cave Junior, version "+getAppProperty("MIDlet-Version")
						+"\nCopyright 2003 Zindell Technologies, Ltd. All rights reserved. Developed by "
						+getAppProperty("MIDlet-Vendor")+" "+getAppProperty("MIDlet-Info-URL")  
						+"\nSoftware is provided \"AS IS\" without warranty of any kind. In no event, shall we be liable for any claim, damages or other liability.";
	final String HELP_STR = "You are a gold miner that was spelled by the old crazy witch who transformed you into a very strange creature. You need to find your way out of the cave. When you get out of the cave, the Sun light will cancel the spell and you will get your body back. On your way out of the cave, you will find weapons that were left by former victims of the crazy witch. In addition to the weapons, you will also find treasures. Try to collect many treasures as possible. They grant you with more points. The weapons you can collect and use during the game include the following: "+
	"Hammer (You can throw it a short distance and collect it again for another usage), Crossbow (You can find a crossbow with 9 arrows. When you shoot the arrows, the crossbow disappears), Sword&Shield (This increases your protection for 5 small battles). You complete a level when you find the map (of that level) that guides you in your way out. Use the navigation keys to move inside the cave and press the fire key to throw a hammer or shoot with your Crossbow. \"Joko Cave Junior\" is a partial version of the game \"Joko Cave\". It includes one level only. If you finish this level then you are prepared for the real game. Please visit at www.jacado.com to buy \"Joko Cave\", the full commercial version. For further assistance, please send us an email at JokoCave@jacado.com."; 
	public JokoCave()
	{
		if (APP_SALE==null) APP_SALE="www.jacado.com";
	}

//*****************************************************************
	public void commandAction(Command c, Displayable d)
	{
		if (c==backCommand)
		{
			currentDisplayable = mainCanvas;
			display.setCurrent(currentDisplayable);
		}
	}
//***************************************************************

	public void startApp()
	{
		if( display == null )
		{

		thread = new Thread()
			{
				public void run()
				{
					try
					{
						display = Display.getDisplay(JokoCave.this);

						//creating loadingForm
						loadingForm = new Form("Loading...");
						currentDisplayable = loadingForm;
						gauge = new Gauge(	"Please wait",false,10,0);
						loadingForm.append(gauge);
						gauge.setValue(0);
						display.setCurrent(loadingForm);

						//creating commands
						exitCommand = new Command("Exit", Command.EXIT, 2);
						backCommand = new Command("Back", Command.BACK,2);

						firstTime = true;

						loadHighScore();

						gauge.setValue(1);
						//creating JokoCaveCanvas
						jokoCaveCanvas = new JokoCaveCanvas(JokoCave.this);
						System.out.println("midlet1");
						gauge.setValue(4); 
//						jokoCaveCanvas.init(1);
						System.out.println("midlet2");
									
						gauge.setValue(7);
						//creating MainCanvas
						mainCanvas = new MainCanvas();
						System.out.println("midlet3");

						gauge.setValue(8);
						//creating the aboutForm
						aboutForm = new Form("About");
						aboutForm.append(ABOUT_STR);
						aboutForm.addCommand(backCommand);
						aboutForm.setCommandListener(JokoCave.this);
						System.out.println("midlet4");
						gauge.setValue(9);
						//creating the helpForm
						helpForm = new Form("Help");
						helpForm.append(HELP_STR);
						helpForm.addCommand(backCommand);
						helpForm.setCommandListener(JokoCave.this);
						System.out.println("midlet5");
						gauge.setValue(10);
						//creating splash
						splashCanvas = new SplashCanvas();
					}
					catch(Exception e)
					{
						e.printStackTrace();
					}

				}
			};
			thread.start();

		}
		else
		{
			display.setCurrent(currentDisplayable);
		}

	}

	public void pauseApp()
	{
		if(currentDisplayable!=mainCanvas)
		{
			currentDisplayable = display.getCurrent();
		}
	}

	public void exit()
	{
		destroyApp(true);
		notifyDestroyed();
	}

	public void destroyApp(boolean cond)
	{
		display = null;
		currentDisplayable = null;

		helpForm = null;
		aboutForm = null;
		mainCanvas = null;
		loadingForm = null;
		
		gauge = null;

		exitCommand = null;
		backCommand = null;

		jokoCaveCanvas = null;
		splashCanvas = null;

		thread = null;
	}
//*****************************************************************
	static byte[] calcScore(int turns)
	{
		byte[] data = new byte[3];

		data[0] = (byte)(turns/10000);
		data[1] = (byte)((turns % 10000)/100);
		data[2] = (byte)(turns % 100);

		return (data);
	}

	private void loadHighScore()
    {
		System.out.println("loadHighScore");    	
		  RecordStore rs = null;
		  byte[] data;
		  try
		  {
				rs = RecordStore.openRecordStore("JokoCaveScores", true);
			   	if(rs.getNumRecords()==1)
			   	{
			   		data = rs.getRecord(1);
		   			highScore = data[0]*10000+ data[1]*100+data[2];
				}
				else
			   	{
					if (rs.getNumRecords()>0) deleteScoresDatabase(); // deletes DB in order to make a new one (correct one)
					rs = RecordStore.openRecordStore("JokoCaveScores", true);
			   		data = calcScore(0); // default scores
		   			rs.addRecord(data, 0, 3);
			   		highScore = 0;
				}
		  }
		  catch(RecordStoreException exception)
		  {
			   deleteScoresDatabase();
			   exception.printStackTrace();
		  }
		  finally
		  {
			  try
			  	{rs.closeRecordStore();}
			  catch(RecordStoreException ex)
			  	{}
		  }
	}

	private void deleteScoresDatabase()
	{
			try
			{
				RecordStore.deleteRecordStore("JokoCaveScores");
			}
			catch(RecordStoreException ex)
			{
				ex.printStackTrace();
			}
	}
//*********************************************************************
	private class SplashCanvas extends com.nokia.mid.ui.FullCanvas
	{

	    private Timer timer = new Timer();
	    private Image splashImg;

	    private SplashCanvas()
	    {
			try
			{
				splashImg = Image.createImage(APP_SPLASH);
			}
			catch(IOException e)
			{
				e.printStackTrace();
			}

			display.setCurrent(this);
	    }

	    protected void showNotify()
		{
			timer.schedule( new CountDown(), 5000 );
	    }

	    private class CountDown extends TimerTask
		{
			public void run()
			{
				dismiss();
			}
	    }

	    protected void keyPressed(int keyCode)
	    {
			dismiss();
	    }

	    protected void pointerPressed(int x, int y)
		{
		    dismiss();
	    }

	    protected void paint(Graphics g)
	    {
			g.drawImage(splashImg, 0, 0, Graphics.LEFT | Graphics.TOP);
	    }

	    private void dismiss()
	    {
			timer.cancel();
			currentDisplayable = mainCanvas;
			splashImg = null;
			display.setCurrent(currentDisplayable);
	    }
	}
//*********************************************************************
	private class MainCanvas extends com.nokia.mid.ui.FullCanvas //implements Runnable
	{
		private int height;
	    private int width;
		private Font boldFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_MEDIUM);
		private Font ulFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD|Font.STYLE_UNDERLINED, Font.SIZE_MEDIUM);
		private int selected=1;
		private boolean bug=false;
		private String [] menu = {"Continue","New game","High score","Turn sound off","Exit","Help","About"};
		private Image menuImg=null;
		
	    private MainCanvas()
	    {
			width = this.getWidth();
			height = this.getHeight();
			try 
			{
				menuImg=Image.createImage("/JokoCaveMenu.png" );
			} 
			catch (IOException e) 
			{
				e.printStackTrace();
			}
	    }

	    protected void keyPressed(int keyCode)
	    {
	    	if (keyCode == com.nokia.mid.ui.FullCanvas.KEY_SOFTKEY1 || keyCode == com.nokia.mid.ui.FullCanvas.KEY_SOFTKEY2) 
			{
				bug=true;
			}
			else
			{	    	
				if (getGameAction(keyCode) == Canvas.DOWN) 
				{
					selected++;
					if (selected>menu.length-1) selected=menu.length-1;
				}
				else
				{
					if (getGameAction(keyCode) == Canvas.UP) 
					{
						selected--;
						if (selected<0) selected=0;				
					}
					else
					{
						if (getGameAction(keyCode)==Canvas.FIRE) 
						{
							switch(selected)
							{
								case 0:// Continue
									if (jokoCaveCanvas.level==0) jokoCaveCanvas.init(1);
									currentDisplayable = jokoCaveCanvas;
//									menuImage = null;
									display.setCurrent(currentDisplayable);					
									break;									
								case 1:// New game
									jokoCaveCanvas.init(1);
									currentDisplayable = jokoCaveCanvas;
//									menuImage = null;
									display.setCurrent(currentDisplayable);					
									break;
								case 2:// High scores
									String scores="Best result : "+highScore;
									Alert alert = new Alert("High Scores:",scores,null,AlertType.INFO);
									alert.setTimeout(4000);
									display.setCurrent(alert,this);
									break;					
								case 3:// Sound
									jokoCaveCanvas.sound = !jokoCaveCanvas.sound;
									if (jokoCaveCanvas.sound)  jokoCaveCanvas.sounds.playSound(0,50); 
									else jokoCaveCanvas.sounds.stopAll(); 									
									break;					
								case 4:
									bug=true;
									break;	
								case 5:// Help
									currentDisplayable = helpForm;
									display.setCurrent(currentDisplayable);
									break;					
								case 6:// About
									currentDisplayable = aboutForm;
									display.setCurrent(currentDisplayable);					
									break;					
							}
						}
					}
				}
			}
			if (bug)
			{
				exit();
			}
			else
			{
				repaint();
				serviceRepaints();
			}
	    }

	    protected void paint(Graphics g)
	    {
//			for(int t=11;t>-3;t--)
//			{
//				g.drawImage(jokoCaveCanvas.graphics,0,(t-1)*JokoCaveCanvas.SIZE,Graphics.LEFT|Graphics.TOP);
//			}
			g.drawImage(menuImg,0,0,Graphics.LEFT|Graphics.TOP);
						
			g.setFont(boldFont);
			g.setColor(0,0,0);
			//g.drawString("JOKO CAVE JUNIOR",(width-boldFont.stringWidth("JOKO CAVE JUNIOR"))/2+2,10+2,Graphics.LEFT|Graphics.TOP);
			for (int i=0; i<menu.length; i++)
			{
				g.drawString(menu[i],width/2+2,75+i*17+2,Graphics.HCENTER|Graphics.TOP);
			}

			g.setColor(255,204,0);
			//g.drawString("JOKO CAVE JUNIOR",(width-boldFont.stringWidth("JOKO CAVE JUNIOR"))/2,10,Graphics.LEFT|Graphics.TOP);
			
			if (jokoCaveCanvas.sound) menu[3]="Turn sound off";
			else menu[3]="Turn sound on";
			for (int i=0; i<menu.length; i++)
			{
				if(i==selected) 
				{
					g.setColor(255,204,0);
					g.setFont(ulFont);
				} 
				else
				{ 
					g.setColor(255,154,0);
					g.setFont(boldFont); 
				} 
				g.drawString(menu[i],width/2,75+i*17,Graphics.HCENTER|Graphics.TOP);
			}
	    }
		
		protected void hideNotify() 
		{
			if (bug) return; 
			jokoCaveCanvas.sounds.stopAll();
		}

		protected void showNotify() 
		{
			if (jokoCaveCanvas.sound)  jokoCaveCanvas.sounds.playSound(0,50); 
		}	    
	}
}

