//filename: JokoCaveCanvas.java

//version for NOKS7650

//Copyright (C) 2003 Zindell Technologies, Ltd.
//All rights reserved. No part of the contents of this program may be
//reproduced or transmitted in any openingForm or by any means without the
//written permission of the publisher.


import java.io.IOException;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;

import com.nokia.mid.ui.FullCanvas;

public class JokoCaveCanvas extends FullCanvas implements Runnable
{
	String aboutStr="";
	final String lastString =  "YOU FAILED IN YOUR TRY.";
	private boolean goOn, bug, bSword, bCrossbow, bHammer, bExit;
	private int screenWidth, screenHeight, lives, score, delay, pX, pY, dX, dY, hX, hY,
		eX, eY, counter, k, l, m, eg, distance, arrows, swcounter, spc, bc,
		levelLength, mX, mY, stepCounter,la, iGo,eg2, wounded;
	int level;
	final static int SIZE=17;
	private final static int LASTLEVEL=2;

	private final static int EMPTY=0, WALL=1, DAVE=2, SPIDER=3, L_SCORPION=4, R_SCORPION=5,
	BAT=6, CROSSBOW=7, SWORD=8, HAMMER=9, DIAMOND=10, PEARL=11, CHERRY=12, MAP=13, ARROW=14,
	EXIT=15, EXP1=16, EXP2=17, R_SCBALL=18, L_SCBALL=19, U_AR=20, R_AR=21, D_AR=22,
	L_AR=23, U_ARROW=24, R_ARROW=25, D_ARROW=26, L_ARROW=27, EXP3=28, EXP4=29,
	R_SCMOVEDBALL=30, RL_SCBALL=31, MOVEDSPIDER=32, MOVEDBAT=33, RMOVEDARROW=34, 
	DMOVEDARROW=35;

	private Font font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_MEDIUM);
	private Font ulFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD|Font.STYLE_UNDERLINED, Font.SIZE_MEDIUM);
	
	private JokoCave midlet;
	NewSound sounds = new NewSound(5);

	int [][] board = new int [12][33];

//    private Font font;

	boolean sound;
//	private Random random = new Random();

	private final long MIN_MEMORY = 70000;

	private Thread t=null;

	Image img;
	Graphics gr;
//	private static Image[] images = new Image[31];
	Image graphics;
//---------------------------------------------------------------

	JokoCaveCanvas(JokoCave mid)
	{
		System.out.println("jokoCaveConstractor");
		eg=0;
		arrows=0;
		bug=false;
		midlet = mid;
		level = 0;
		k=l=m=0;
		sound = true;
		score=0;
		lives=7;
		screenWidth = this.getWidth();
		screenHeight = this.getHeight();
		JokoCave.gauge.setValue(5);
//		font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_SMALL);
		try
		{
			graphics = Image.createImage("/graphics.png");
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		delay=120;
		System.out.println("jokoCaveConstractorEnd");		
	}

// ---------------------------------------------------------------

public void init(int lvl)
{
	System.out.println("init()");
	levelLength=33;	
	try
	{
		if(Runtime.getRuntime().freeMemory() < MIN_MEMORY) System.gc();
		if(img==null)
		{
			img=Image.createImage(SIZE*12,SIZE*33);
			gr=img.getGraphics();
		}
		
		System.out.println("init0");		

		la=0;
		bExit=false;
		iGo=0;
		this.level = lvl;
	
		switch(level)
		{
			case 1:
				arrows=0;
				lives=7;
				bHammer=false;
				bSword=false;
				bCrossbow=false;
				bug=false;
				pX=6;
				pY=31;
				score=0;
				spc=5;
				bc=4;
				for (int i=0; i<12; i++)
				{
					for (int j=0; j<33; j++)
					{
						if((i==0 || i==11 || j==0 || j==32) ||(j==3 && i<8) || (j==5 && i>6) ||
							(i==7 && j>4 && j<9) || (j==8 && i<4) || (i==3 && j>7 && j<11) ||
							 (j==10 && i>2 && i<9) || (j==15 && i!=7) || (j==17 && i==6) ||
							  (i==9 && j>17 && j<21) || (j==20 && i>4 && i<10) ||
							   (j==21 && i>2 && i<6) || (i==3 && j>21 && j<25) || (j==23 && i>6) ||
							    (j==24 && (i<4 || i==7 || i==11)) || (j==26 && i>2 && i<10))
					    {
							     board[i][j]=WALL;
							 gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);    
						     gr.drawImage(graphics,(i-8)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
					    }
					    else
					    {
					    	board[i][j]=EMPTY;
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
					    }
					}
				}
				hX=3;hY=30;
				board[hX][hY]=HAMMER;
				board[pX][pY]=DAVE;
				board[1][26]=board[10][25]=board[1][21]=board[10][18]=board[1][17]=board[6][16]=board[2][10]=board[8][6]=board[8][3]=board[10][2]=SPIDER;
				board[5][1]=board[6][2]=board[1][4]=board[1][10]=BAT;
				board[4][1]=board[4][2]=board[1][14]=board[7][25]=R_SCORPION;
				board[10][14]=board[5][25]=L_SCORPION;
				board[1][23]=CROSSBOW;
				board[9][24]=CHERRY;
				board[4][9]=PEARL;
				board[8][30]=SWORD;
				board[1][7]=board[1][9]=board[2][23]=board[6][25]=DIAMOND;
				eX=1;eY=1;
				mX=2;mY=9;
				board[mX][mY]=MAP;
				break;

			case 2:
			case 3:
			case 4:
			case 5:
			default:
				break;
		}
	}
	catch(Exception e)
	{
		aboutStr=aboutStr+e.getMessage();
	}
}

//---------------------------------------------------------------
public void paint(Graphics g)
{
	System.out.println("in paint()");
	if(Runtime.getRuntime().freeMemory() < MIN_MEMORY) System.gc();
	g.setClip(0,0,screenWidth,screenHeight);
	g.setColor(0,0,0);
	g.fillRect(0,0,screenWidth,screenHeight);

	if (bExit || level==LASTLEVEL)
	{
		levelAnimation(g);
		return;
	}
	else
	{
		if (iGo>0)
		{
			l++;
			if (l>1) l=0;
		}
		counter++;
		if (counter>12) counter=1;

		k++;
		if (k>1) k=0;

////	Dave wounded...
		wounded=0;
System.out.println("1");		
		if (board[pX-1][pY]==R_SCORPION && counter==3)
		{
			wounded++;
		}
		if (board[pX+1][pY]==L_SCORPION && counter==9)
		{
			wounded++;
		}

		if (board[pX-1][pY]==SPIDER ||	board[pX-1][pY]==R_SCBALL)
		{
			wounded++;
			board[pX-1][pY]=EMPTY;
			//gr.drawImage(images[IEMPTY],(pX-1)*SIZE,pY*SIZE,Graphics.LEFT|Graphics.TOP);
			//EMPTY
			gr.setClip((pX-1)*SIZE,pY*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX-1-9)*SIZE, (pY-1)*SIZE, Graphics.LEFT|Graphics.TOP);
		}
		if (board[pX+1][pY]==SPIDER ||	board[pX+1][pY]==L_SCBALL)
		{
			wounded++;
			board[pX+1][pY]=EMPTY;
			//gr.drawImage(images[IEMPTY],(pX+1)*SIZE,pY*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip((pX+1)*SIZE,pY*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX+1-9)*SIZE, (pY-1)*SIZE, Graphics.LEFT|Graphics.TOP);
			
		}
		if (board[pX][pY-1]==SPIDER)
		{
			wounded++;
			board[pX][pY-1]=EMPTY;
//			gr.drawImage(images[IEMPTY],pX*SIZE,(pY-1)*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip(pX*SIZE,(pY-1)*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX-9)*SIZE, (pY-1-1)*SIZE, Graphics.LEFT|Graphics.TOP);

		}
		if (board[pX][pY+1]==SPIDER)
		{
			wounded++;
			board[pX][pY+1]=EMPTY;
//			gr.drawImage(images[IEMPTY],pX*SIZE,(pY+1)*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip(pX*SIZE,(pY+1-1)*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX-9)*SIZE, (pY+1-1)*SIZE, Graphics.LEFT|Graphics.TOP);

		}

		if (board[pX-1][pY-1]==BAT)
		{
			wounded++;
			board[pX-1][pY-1]=EMPTY;
//			gr.drawImage(images[IEMPTY],(pX-1)*SIZE,(pY-1)*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip((pX-1)*SIZE,(pY-1)*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX-1-9)*SIZE, (pY-1-1)*SIZE, Graphics.LEFT|Graphics.TOP);

		}
		if (board[pX-1][pY+1]==BAT)
		{
			wounded++;
			board[pX-1][pY+1]=EMPTY;
//			gr.drawImage(images[IEMPTY],(pX-1)*SIZE,(pY+1)*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip((pX-1)*SIZE,(pY+1)*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX-1-9)*SIZE, (pY+1-1)*SIZE, Graphics.LEFT|Graphics.TOP);
		}
		if (board[pX+1][pY-1]==BAT)
		{
			wounded++;
			board[pX+1][pY-1]=EMPTY;
//			gr.drawImage(images[IEMPTY],(pX+1)*SIZE,(pY-1)*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip((pX+1)*SIZE,(pY-1)*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX+1-9)*SIZE, (pY-1-1)*SIZE, Graphics.LEFT|Graphics.TOP);
		}
		if (board[pX+1][pY+1]==BAT)
		{
			wounded++;
			board[pX+1][pY+1]=EMPTY;
//			gr.drawImage(images[IEMPTY],(pX+1)*SIZE,(pY+1)*SIZE,Graphics.LEFT|Graphics.TOP);
			gr.setClip((pX+1)*SIZE,(pY+1)*SIZE,SIZE,SIZE);					    	
			gr.drawImage(graphics,(pX+1-9)*SIZE, (pY+1-1)*SIZE, Graphics.LEFT|Graphics.TOP);
		}
System.out.println("2");

		check(pX+dX,pY+dY);

System.out.println("3");		

		if (wounded>0)
		{
			board[pX][pY]=EXP1;
			if (!bug && !bSword) lives=lives-3*wounded;
			else
			{
				if (!bug && bSword)
				{
					for (int u=0; u<wounded; u++)
					{
						lives--;
						swcounter--;
						if (swcounter<1)
						{
							swcounter=0;
							bSword=false;
							lives=lives-2;
						}
					}
				}
			}
			if (lives<1)
			{
				init(1);
				midlet.display.setCurrent(midlet.mainCanvas);
				return;
			}
			wounded=0;
		}

		for (int i=0; i<12;i++)
		{
			for (int j=0; j<levelLength;j++)
			{
				switch (board[i][j])
				{
					case U_ARROW:
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						if(checkShoot(i,j-1,U_ARROW)) board[i][j]=HAMMER;
						break;
					case R_ARROW:
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						if(checkShoot(i+1,j,R_ARROW)) board[i][j]=HAMMER;
						break;
					case D_ARROW:
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						if(checkShoot(i,j+1,D_ARROW)) board[i][j]=HAMMER;
						break;
					case L_ARROW:
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						if(checkShoot(i-1,j,L_ARROW)) board[i][j]=HAMMER;
						break;

					case RMOVEDARROW:
						board[i][j]=R_ARROW;
						break;
					case DMOVEDARROW:
						board[i][j]=D_ARROW;
						break;

					case R_SCBALL:
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						
						if (board[i+1][j]==EMPTY) board[i+1][j]=R_SCMOVEDBALL;
						if (board[i+1][j]==L_SCBALL)
						{
							board[i+1][j]=R_SCMOVEDBALL;
							board[i][j]=L_SCBALL;
						}
						break;
					case L_SCBALL:
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
					gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
					gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

						if (board[i-1][j]==EMPTY) board[i-1][j]=L_SCBALL;
						if (board[i-1][j]==R_SCBALL) board[i-1][j]=RL_SCBALL;
						break;
					case R_SCMOVEDBALL:
						board[i][j]=R_SCBALL;
						break;
					case RL_SCBALL:
						board[i-1][j]=L_SCBALL;
						board[i+1][j]=R_SCBALL;
						board[i][j]=EMPTY;
//						gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
					gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
					gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

						break;

					case EXP4:
						if (distance>12)
						{
							board[i][j]=EMPTY;
//							gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						}
						else
						{
							board[i][j]=HAMMER;
//							gr.drawImage(images[IHAMMER],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-0)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						}
						break;

					case SPIDER:
						if (pY>j+spc) break;

						if (pX>i && pX<i+spc && board[i+1][j]==EMPTY)
						{
							board[i][j]=EMPTY;
//							gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
							board[i+1][j]=MOVEDSPIDER;
						}
						else
						{
							if (pX<i && pX>i-spc && board[i-1][j]==EMPTY)
							{
								board[i][j]=EMPTY;
//								gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
								gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
								gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
								board[i-1][j]=SPIDER;
							}
							else
							{
								if (pY<j && board[i][j-1]==EMPTY)
								{
									board[i][j]=EMPTY;
//									gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
									gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
									gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
									board[i][j-1]=SPIDER;
								}
								else
								{
									if (pY>j && board[i][j+1]==EMPTY)
									{
										board[i][j]=EMPTY;
//										gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
										gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
										gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
										board[i][j+1]=MOVEDSPIDER;
									}
								}
							}
						}
						break;

					case MOVEDSPIDER:
						board[i][j]=SPIDER;
						break;

					case BAT:
						if(pY>j+bc) break;

						if (pX>=i && pY>j && board[i+1][j+1]==EMPTY)
						{
							board[i][j]=EMPTY;
//							gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
							board[i+1][j+1]=MOVEDBAT;
						}
						else
						{
							if (pX<i && pY<=j && board[i-1][j-1]==EMPTY)
							{
								board[i][j]=EMPTY;
//								gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
								gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
								gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
								board[i-1][j-1]=BAT;
							}
							else
							{
								if (pX>=i && pY<=j && board[i+1][j-1]==EMPTY)
								{
									board[i][j]=EMPTY;
//									gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
									gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
									gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

									board[i+1][j-1]=BAT;
								}
								else
								{
									if (pX<i && pY>j && (pY-5)<j && board[i-1][j+1]==EMPTY)
									{
										board[i][j]=EMPTY;
//										gr.drawImage(images[IEMPTY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
										gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
										gr.drawImage(graphics,(i-9)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

										board[i-1][j+1]=MOVEDBAT;
									}
								}
							}
						}
						break;

					case MOVEDBAT:
						board[i][j]=BAT;
						break;
				}
			}
		}
System.out.println("4");		

		for (int i=0; i<12;i++)
		{
			for (int j=0; j<levelLength;j++)
			{
				switch (board[i][j])
				{
					case HAMMER:
//						gr.drawImage(images[IHAMMER],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-0)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

						break;
					case CROSSBOW:
//						gr.drawImage(images[ICROSSBOW],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-1)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

						break;
					case SWORD:
//						gr.drawImage(images[ISWORD],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-2)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

						break;
					case DAVE:
						if (pY<2) board[mX][mY]=MAP;
						if (!bHammer && board[hX][hY]==EMPTY)
						{
							board[hX][hY]=HAMMER;
						}
//						gr.drawImage(images[IUDAVE1+m+l*4],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-2-m-l*4)*SIZE, (j-0)*SIZE, Graphics.LEFT|Graphics.TOP);

						break;
					case SPIDER:
//						gr.drawImage(images[ISPIDER],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-3)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);

						break;
					case BAT:
//						gr.drawImage(images[IBAT0+k],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-5-k)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
					case L_SCORPION:
						if (counter==9 && board[i-1][j]==EMPTY)
						{
							board[i-1][j]=L_SCBALL;
//							gr.drawImage(images[ILSCORPION],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
//							gr.drawImage(images[ISCBALL],(i-1)*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-7)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
							gr.setClip((i-1)*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-1-5)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						}
						else
						{
//							gr.drawImage(images[ILSCORPION],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-7)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						}	
						break;
					case R_SCORPION:
						if (counter==3 && board[i+1][j]==EMPTY)
						{
							board[i+1][j]=R_SCMOVEDBALL;
//							gr.drawImage(images[IRSCORPION],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
//							gr.drawImage(images[ISCBALL],(i+1)*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-4)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
							gr.setClip((i+1)*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i+1-5)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						}
						else
						{
//							gr.drawImage(images[IRSCORPION],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
							gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
							gr.drawImage(graphics,(i-4)*SIZE, (j-1)*SIZE, Graphics.LEFT|Graphics.TOP);
						}
						break;
					case R_SCMOVEDBALL:
						board[i][j]=R_SCBALL;
						break;
					case U_ARROW:
					case R_ARROW:
					case D_ARROW:
					case L_ARROW:
					case R_SCBALL:
					case L_SCBALL:
//						gr.drawImage(images[ISCBALL],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-5)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
					case U_AR:
					case R_AR:
					case D_AR:
					case L_AR:
//						gr.drawImage(images[ISCBALL],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-5)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						board[i][j]=board[i][j]+4;
						break;
					case DIAMOND:
//						gr.drawImage(images[IDIAMOND],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-3)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);	
						break;
					case PEARL:
//						gr.drawImage(images[IPEARL],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-0)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
					case CHERRY:
//						gr.drawImage(images[ICHERRY],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-1)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
					case MAP:
//						gr.drawImage(images[IMAP],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-4)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
					case EXP2:
//						gr.drawImage(images[IEXP1],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-1)*SIZE, (j-0)*SIZE, Graphics.LEFT|Graphics.TOP);
						board[i][j]=DAVE;
						break;
					case EXP1:
//						gr.drawImage(images[IEXP0],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-0)*SIZE, (j-0)*SIZE, Graphics.LEFT|Graphics.TOP);
						board[i][j]=EXP2;
						break;
					case EXP4:
//						gr.drawImage(images[IEXP1],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-1)*SIZE, (j-0)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
					case EXP3:
//						gr.drawImage(images[IEXP0],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-0)*SIZE, (j-0)*SIZE, Graphics.LEFT|Graphics.TOP);
						board[i][j]=EXP4;
						break;
					case EXIT:
//						gr.drawImage(images[IEXIT],i*SIZE,j*SIZE,Graphics.LEFT|Graphics.TOP);
						gr.setClip(i*SIZE,j*SIZE,SIZE,SIZE);					    	
						gr.drawImage(graphics,(i-2)*SIZE, (j-2)*SIZE, Graphics.LEFT|Graphics.TOP);
						break;
				}
			}
		}

		if (pY>9) g.drawImage(img,screenWidth/2,0-pY*SIZE+10*SIZE,Graphics.HCENTER|Graphics.TOP);
		else g.drawImage(img,screenWidth/2,SIZE,Graphics.HCENTER|Graphics.TOP);
		g.setColor(0,0,0);
		g.fillRect(0,0,screenWidth,18);
		g.setColor(0,255,0);
		g.setFont(font);
		g.setClip(0,0,screenWidth,screenHeight);
//		g.drawString(""+Runtime.getRuntime().freeMemory(),screenWidth-1,4,Graphics.TOP|Graphics.RIGHT);
		if(score>9999) g.drawString(""+score,screenWidth-1,4,Graphics.TOP|Graphics.RIGHT);
		else
		{
			if(score>999) g.drawString("0"+score,screenWidth-1,4,Graphics.TOP|Graphics.RIGHT);
			else
			{
				if(score>99) g.drawString("00"+score,screenWidth-1,4,Graphics.TOP|Graphics.RIGHT);
				else
				{
					if(score>9) g.drawString("000"+score,screenWidth-1,4,Graphics.TOP|Graphics.RIGHT);
					else g.drawString("0000"+score,screenWidth-1,4,Graphics.TOP|Graphics.RIGHT);
				}
			}
		}

		if (lives>2 || k==0) 
		{
//			g.drawImage(images[IICON],1,2,Graphics.LEFT|Graphics.TOP);
			g.setClip(1,3,SIZE,SIZE);					    	
			g.drawImage(graphics,1-10*SIZE, 3-0*SIZE, Graphics.LEFT|Graphics.TOP);
		} 
		g.setClip(0,0,screenWidth,screenHeight);
		g.setColor(0,255,0);
		g.drawString(""+lives,20,4,Graphics.TOP|Graphics.LEFT);

		g.setColor(255,130,0);
		if(bHammer)
		{
			if(bCrossbow)
			{ 
//				g.drawImage(images[IHAMMER1],28,1,Graphics.LEFT|Graphics.TOP);
				g.setClip(54,1,SIZE,SIZE);					    	
				g.drawImage(graphics,54-9*SIZE, 1-2*SIZE, Graphics.LEFT|Graphics.TOP); 
			} 
			else 
			{
//				g.drawImage(images[IHAMMER0],28,1,Graphics.LEFT|Graphics.TOP);
				g.setClip(54,1,SIZE,SIZE);					    	
				g.drawImage(graphics,54-8*SIZE, 1-2*SIZE, Graphics.LEFT|Graphics.TOP); 
			} 
		}
		if(bSword)
		{
//			g.drawImage(images[ISWORD0],64,1,Graphics.LEFT|Graphics.TOP);
			g.setClip(106,1,SIZE,SIZE);					    	
			g.drawImage(graphics,106-6*SIZE, 1-2*SIZE, Graphics.LEFT|Graphics.TOP);
			g.setClip(0,0,screenWidth,screenHeight);
			g.drawString(""+swcounter,130,4,Graphics.TOP|Graphics.RIGHT);
		}
		if(bCrossbow)
		{
//			g.drawImage(images[ICROSSBOW0],55,1,Graphics.LEFT|Graphics.TOP);
			g.setClip(76,1,SIZE,SIZE);					    	
			g.drawImage(graphics,76-7*SIZE, 1-2*SIZE, Graphics.LEFT|Graphics.TOP);
			g.setClip(0,0,screenWidth,screenHeight); 
			g.drawString(""+arrows,100,4,Graphics.TOP|Graphics.RIGHT);
		}
	}
	iGo--;
	if (iGo<1)
	{
		dX=dY=0;
	}
}
//---------------------------------------------------------------
	private void levelAnimation(Graphics gg)
	{
		for(int t=11;t>-3;t--)
		{
			gg.drawImage(graphics,0,(t-1)*SIZE,Graphics.LEFT|Graphics.TOP);
		}

		gg.setFont(font);
		
		if (level<LASTLEVEL)
		{
			gg.setColor(0,0,0);
			gg.drawString("CONGRATULATIONS!",(screenWidth-font.stringWidth("CONGRATULATIONS!"))/2+2,2+12,Graphics.LEFT|Graphics.TOP);
			gg.drawString("LEVEL "+level+" HAS JUST",(screenWidth-font.stringWidth("LEVEL "+level+" HAS JUST"))/2+2,2+42,Graphics.LEFT|Graphics.TOP);
			gg.drawString("BEEN COMPLETED.",(screenWidth-font.stringWidth("BEEN COMPLETED."))/2+2,2+62,Graphics.LEFT|Graphics.TOP);
			if (isHighestScore()) gg.drawString("Best result in level "+level+"!",(screenWidth-font.stringWidth("Best result in level "+level+"!"))/2+2,2+92,Graphics.LEFT|Graphics.TOP);
			else gg.drawString("Well done!",(screenWidth-font.stringWidth("Well done!"))/2+2,2+92,Graphics.LEFT|Graphics.TOP);
			gg.drawString("Your score is "+score+"!",(screenWidth-font.stringWidth("Your score is "+score+"!"))/2+2,2+122,Graphics.LEFT|Graphics.TOP);
			gg.drawString("PRESS THE FIRE KEY",(screenWidth-font.stringWidth("PRESS THE FIRE KEY"))/2+2,2+152,Graphics.LEFT|Graphics.TOP);
			gg.drawString("TO CONTINUE",(screenWidth-font.stringWidth("TO CONTINUE"))/2+2,2+172,Graphics.LEFT|Graphics.TOP);
			
			gg.setColor(255,204,0);
			gg.drawString("CONGRATULATIONS!",(screenWidth-font.stringWidth("CONGRATULATIONS!"))/2,12,Graphics.LEFT|Graphics.TOP);
			gg.setColor(255,154,0);
			gg.drawString("LEVEL "+level+" HAS JUST",(screenWidth-font.stringWidth("LEVEL "+level+" HAS JUST"))/2,42,Graphics.LEFT|Graphics.TOP);
			gg.drawString("BEEN COMPLETED.",(screenWidth-font.stringWidth("BEEN COMPLETED."))/2,62,Graphics.LEFT|Graphics.TOP);
			
			if (isHighestScore()) gg.drawString("Best result in level "+level+"!",(screenWidth-font.stringWidth("Best result in level "+level+"!"))/2,92,Graphics.LEFT|Graphics.TOP);
			else gg.drawString("Well done!",(screenWidth-font.stringWidth("Well done!"))/2,92,Graphics.LEFT|Graphics.TOP);
			
			gg.drawString("Your score is "+score+"!",(screenWidth-font.stringWidth("Your score is "+score+"!"))/2,122,Graphics.LEFT|Graphics.TOP);
			
			gg.drawString("PRESS THE FIRE KEY",(screenWidth-font.stringWidth("PRESS THE FIRE KEY"))/2,152,Graphics.LEFT|Graphics.TOP);
			gg.drawString("TO CONTINUE",(screenWidth-font.stringWidth("TO CONTINUE"))/2,172,Graphics.LEFT|Graphics.TOP);
		}
		else
		{
//			gg.setColor(0,0,0);
//			gg.drawString("CONGRATULATIONS!",(screenWidth-font.stringWidth("CONGRATULATIONS!"))/2+2,9+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("You have just won",(screenWidth-font.stringWidth("You have just won"))/2+2,27+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("the cruel witch!",(screenWidth-font.stringWidth("the cruel witch!"))/2+2,39+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("You found a way",(screenWidth-font.stringWidth("You found a way"))/2+2,57+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("from the dark cavern",(screenWidth-font.stringWidth("from the dark cavern"))/2+2,69+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("and destroed the",(screenWidth-font.stringWidth("and destroed the"))/2+2,81+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("witches magic!",(screenWidth-font.stringWidth("witches magic!"))/2+2,92+2,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("Now you are RICH!",(screenWidth-font.stringWidth("Now you are RICH!"))/2+2,110+2,Graphics.LEFT|Graphics.TOP);
//									
//			gg.setColor(255,204,0);
//			gg.drawString("CONGRATULATIONS!",(screenWidth-font.stringWidth("CONGRATULATIONS!"))/2,9,Graphics.LEFT|Graphics.TOP);
//			gg.setColor(255,154,0);
//			gg.drawString("You have just won",(screenWidth-font.stringWidth("You have just won"))/2,27,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("the cruel witch!",(screenWidth-font.stringWidth("the cruel witch!"))/2,39,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("You found a way",(screenWidth-font.stringWidth("You found a way"))/2,57,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("from the dark cavern",(screenWidth-font.stringWidth("from the dark cavern"))/2,69,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("and destroed the",(screenWidth-font.stringWidth("and destroed the"))/2,81,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("witches magic!",(screenWidth-font.stringWidth("witches magic!"))/2,92,Graphics.LEFT|Graphics.TOP);
//			gg.drawString("Now you are RICH!",(screenWidth-font.stringWidth("Now you are RICH!"))/2,110,Graphics.LEFT|Graphics.TOP);

			gg.setColor(0,0,0);
			gg.drawString("CONGRATULATIONS!",(screenWidth-font.stringWidth("CONGRATULATIONS!"))/2+2,2+12,Graphics.LEFT|Graphics.TOP);
			gg.drawString("Now that you have",(screenWidth-font.stringWidth("Now that you have"))/2+2,2+44,Graphics.LEFT|Graphics.TOP);
			gg.drawString("mastered",(screenWidth-font.stringWidth("mastered"))/2+2,2+66,Graphics.LEFT|Graphics.TOP);
			gg.drawString("Joko Cave Junior",(screenWidth-font.stringWidth("Joko Cave Junior"))/2+2,2+88,Graphics.LEFT|Graphics.TOP);
			gg.drawString("get the real thing,",(screenWidth-font.stringWidth("get the real thing,"))/2+2,2+110,Graphics.LEFT|Graphics.TOP);
			gg.drawString("the full version of",(screenWidth-font.stringWidth("the full version of"))/2+2,2+132,Graphics.LEFT|Graphics.TOP);
			gg.drawString("JokoCave at",(screenWidth-font.stringWidth("JokoCave at"))/2+2,2+154,Graphics.LEFT|Graphics.TOP);
			gg.drawString(""+midlet.APP_SALE,(screenWidth-font.stringWidth(""+midlet.APP_SALE))/2+2,2+176,Graphics.LEFT|Graphics.TOP);

			gg.setColor(255,204,0);
			gg.drawString("CONGRATULATIONS!",(screenWidth-font.stringWidth("CONGRATULATIONS!"))/2,12,Graphics.LEFT|Graphics.TOP);
			gg.setColor(255,154,0);
			gg.drawString("Now that you have",(screenWidth-font.stringWidth("Now that you have"))/2,44,Graphics.LEFT|Graphics.TOP);
			gg.drawString("mastered",(screenWidth-font.stringWidth("mastered"))/2,66,Graphics.LEFT|Graphics.TOP);
			gg.drawString("Joko Cave Junior",(screenWidth-font.stringWidth("Joko Cave Junior"))/2,88,Graphics.LEFT|Graphics.TOP);
			gg.drawString("get the real thing,",(screenWidth-font.stringWidth("get the real thing,"))/2,110,Graphics.LEFT|Graphics.TOP);
			gg.drawString("the full version of",(screenWidth-font.stringWidth("the full version of"))/2,132,Graphics.LEFT|Graphics.TOP);
			gg.drawString("JokoCave at",(screenWidth-font.stringWidth("JokoCave at"))/2,154,Graphics.LEFT|Graphics.TOP);
			gg.setFont(ulFont);
			gg.setColor(250,100,250);
			gg.drawString(""+midlet.APP_SALE,(screenWidth-font.stringWidth(""+midlet.APP_SALE))/2,176,Graphics.LEFT|Graphics.TOP);

			isHighestScore();
		}
	}

//---------------------------------------------------------------
	protected void keyPressed(int keyCode)
	{
		dX=0;dY=0;
		if (keyCode == FullCanvas.KEY_SOFTKEY1 || keyCode == FullCanvas.KEY_SOFTKEY2 || level>=LASTLEVEL)
		{
			isHighestScore();
			stopAnimation();
			midlet.display.setCurrent(midlet.mainCanvas);
			return;
		}

//		if (board[pX][pY]!=DAVE) return;

		if (keyCode == FullCanvas.KEY_SOFTKEY3 || keyCode == FullCanvas.KEY_NUM5)
		{
			if(bExit)
			{
				if (level==LASTLEVEL)
				{
					level=1;
					init(level);
					bExit=false;
					midlet.display.setCurrent(midlet.mainCanvas);
				}
				else
				{
					init(++level);
					bExit=false;
				}
				return;
			}
			
//moved			
			if (board[pX][pY]!=DAVE) return;
			
			if(bHammer || bCrossbow)
			{
				if (bCrossbow)
				{
					if(sound) sounds.playSound(4);
					distance=100;
					arrows--;
					if (arrows<1) bCrossbow=false;
				}
				else
				{
					if(sound) sounds.playSound(3);
					distance=2;
					bHammer=false;
				}
				switch(m)
				{
					case 0:
						if (board[pX][pY-1]!=WALL) board[pX][pY-1]=U_AR;
						break;
					case 1:
						if (board[pX+1][pY]!=WALL) board[pX+1][pY]=R_AR;
						break;
					case 2:
						if (board[pX][pY+1]!=WALL) board[pX][pY+1]=D_AR;
						break;
					case 3:
						if (board[pX-1][pY]!=WALL) board[pX-1][pY]=L_AR;
						break;
				}
			}
		}

//moved
		if (board[pX][pY]!=DAVE) return;

		if (keyCode == FullCanvas.KEY_LEFT_ARROW || keyCode == FullCanvas.KEY_NUM4)
		{
			iGo=1;
			if(m==3) dX=-1;
			m=3;
			return;
		}
		if (keyCode == FullCanvas.KEY_RIGHT_ARROW || keyCode == FullCanvas.KEY_NUM6)
		{
			iGo=1;
			if(m==1) dX=1;
			m=1;
			return;
		}
		if (keyCode == FullCanvas.KEY_UP_ARROW || keyCode == FullCanvas.KEY_NUM2)
		{
			iGo=1;
			if(m==0) dY=-1;
			m=0;
			return;
		}
		if (keyCode == FullCanvas.KEY_DOWN_ARROW || keyCode == FullCanvas.KEY_NUM8)
		{
			iGo=1;
			if(m==2) dY=1;
			m=2;
			return;
		}
		if (keyCode == FullCanvas.KEY_NUM1)
		{
			delay=delay+10;
		}
		if (keyCode == FullCanvas.KEY_NUM4)
		{
			delay=delay-10;
		}

		if (keyCode == FullCanvas.KEY_POUND)
		{
			eg++;
			if (eg%3==0) bug=true;
			if (eg%5==0)
			{
				board[pX][pY+1]=EXIT;
				eg=0;
			}
		}
		if (keyCode == FullCanvas.KEY_STAR)
		{
			eg2++;
			if (eg2%3==0) lives=99;
		}

	}//end of keyPressed
//---------------------------------------------------------------
	protected void keyReleased(int keyCode)
	{
		if (iGo>1) iGo=0;
	}
//---------------------------------------------------------------
	protected void keyRepeated(int keyCode)
	{
		if (keyCode == FullCanvas.KEY_LEFT_ARROW || keyCode == FullCanvas.KEY_NUM4)
		{
			iGo=100;
			m=3;dX=-1;
			return;
		}
		if (keyCode == FullCanvas.KEY_RIGHT_ARROW || keyCode == FullCanvas.KEY_NUM6)
		{
			iGo=100;
			m=1;dX=1;
			return;
		}
		if (keyCode == FullCanvas.KEY_UP_ARROW || keyCode == FullCanvas.KEY_NUM2)
		{
			iGo=100;
			m=0;dY=-1;
			return;
		}
		if (keyCode == FullCanvas.KEY_DOWN_ARROW || keyCode == FullCanvas.KEY_NUM8)
		{
			iGo=100;
			m=2;dY=1;
			return;
		}
	}
//---------------------------------------------------------------
	private boolean check(int ppX, int ppY)
	{
		int sn=-1;
		boolean result=false;
		if(ppX<0) ppX=0;
		if(ppX>11) ppX=11;
		if(ppY<0) ppY=0;
		if(ppY>levelLength-1) ppY=levelLength-1;
		if (board[ppX][ppY]==WALL) return false;

		board[pX][pY]=EMPTY;
//		gr.drawImage(images[IEMPTY],pX*SIZE,pY*SIZE,Graphics.LEFT|Graphics.TOP);
		gr.setClip(pX*SIZE,pY*SIZE,SIZE,SIZE);					    	
		gr.drawImage(graphics,(pX-9)*SIZE, (pY-1)*SIZE, Graphics.LEFT|Graphics.TOP);

		switch(board[ppX][ppY])
		{
			case HAMMER:
				bHammer=true;
				sn=3;
				break;
			case CROSSBOW:
				bCrossbow=true;
				arrows=9;
				sn=4;
				break;
			case SWORD:
				bSword=true;
				swcounter=5;
				sn=2;
				break;
			case SPIDER:
			case BAT:
			case L_SCORPION:
			case R_SCORPION:
			case R_SCBALL:
			case L_SCBALL:
				result=true;
				sn=1;
				break;
			case DIAMOND:
				score=score+100;
				sn=2;
				break;
			case PEARL:
				score=score+150;
				sn=2;
				break;
			case CHERRY:
				lives++;
				if (lives>14) lives=14;
				sn=2;
				break;
			case MAP:
				board[eX][eY]=EXIT;
				board[eX][eY+1]=EXIT;
				sn=2;
				break;
			case EXIT:
				bExit=true;
				break;
		}
		if (score%2000<150 && score>2000)
		{
			lives=lives++;
			if (lives>14) lives=14;
			score=score+150;
			sn=2;
		}
		if(sound && sn>0) sounds.playSound(sn);
		pX=ppX;
		pY=ppY;
		if(result) wounded++;
		else board[pX][pY]=DAVE;

		return result;
	}
//---------------------------------------------------------
	private boolean checkShoot(int ppX, int ppY, int arrow)
	{
		if (board[ppX][ppY]==WALL)
		{
			if (distance<12) return true;
			else return false;
		}

		int sn=0;
		int par=0;
		par=board[ppX][ppY];
		switch(par)
		{
			case HAMMER:
			case CROSSBOW:
			case SWORD:
			case DIAMOND:
			case PEARL:
			case CHERRY:
			case MAP:
				board[ppX][ppY]=EXP3;
				sn=2;
				break;
			case R_SCBALL:
			case L_SCBALL:
				score=score+5;
			case L_SCORPION:
			case R_SCORPION:
				score=score+30;
			case SPIDER:
				score=score+50;
			case BAT:
				score=score+80;
				board[ppX][ppY]=EXP3;
				sn=1;
				break;
			default:
				if (distance<0)
				{
					board[ppX][ppY]=HAMMER;
				}
				else
				{
					if (arrow==L_ARROW || arrow==U_ARROW) board[ppX][ppY]=arrow;
					else
					{
						if (arrow==R_ARROW) board[ppX][ppY]=RMOVEDARROW;
						else board[ppX][ppY]=DMOVEDARROW;
					}
				}
			break;
		}
		distance--;
		if(sound && sn>0) sounds.playSound(sn);
		return false;
	}

//--------------------------------------------------------------
	public void run()
	{
		while(goOn)
		{
			if(Runtime.getRuntime().freeMemory() < MIN_MEMORY)
			{
				System.gc();
			}
			repaint();
			serviceRepaints();

			try
			{
				Thread.sleep(delay);
			}
			catch(InterruptedException e)
			{
				e.printStackTrace();
			}
		}
	}

//---------------------------------------------------------------
	void startAnimation()
	{
		if(JokoCave.DEBUG) System.out.println("in startAnimation");
		if(Runtime.getRuntime().freeMemory() < MIN_MEMORY) System.gc();
		goOn = true;

		if(t==null)
		{
			t = new Thread(this);
			t.start();
		}
		else resumeAnimation();
	}
//---------------------------------------------------------------

	void pauseAnimation()
	{
		stopAnimation();
	}
//---------------------------------------------------------------
	void restoreAfterInterruption()
	{
		if(Runtime.getRuntime().freeMemory() < MIN_MEMORY) System.gc();
	}
//---------------------------------------------------------------
	void resumeAnimation()
	{
		if(JokoCave.DEBUG) System.out.println("in resumeAnimation()");
		if(Runtime.getRuntime().freeMemory() < MIN_MEMORY) System.gc();
		goOn=true;
	}
//---------------------------------------------------------------
	void stopAnimation()
	{
		if(JokoCave.DEBUG) System.out.println("in stopAnimation()");
		goOn = false;
		t = null;
		if(Runtime.getRuntime().freeMemory() < MIN_MEMORY) System.gc();
	}
//----------------------------------------------------------------
private boolean isHighestScore(){
		if(JokoCave.DEBUG) System.out.println("in isHighestScore");
		RecordStore rs = null;
		boolean result = false;
		if (score>=JokoCave.highScore)
		{ // Top score update
			JokoCave.highScore = score;
			byte[] data = new byte[3];
			try
			{
				rs = RecordStore.openRecordStore("JokoCaveScores", false);
				data = JokoCave.calcScore(score);
				rs.setRecord(1, data, 0,3); // update the needed record
			}
			catch(RecordStoreException exception)
			{
			   exception.printStackTrace();
			}
			finally
			{
				try {rs.closeRecordStore();}
				catch(RecordStoreException ex){}
			}

			result = true;
		}
		else result = false;

		rs = null;
		return result;
	}
//-----------------------------------------------------------------
//invoked when something is drawn upon Canvas
//should work for the incoming calls and accidental pressing Menu button
	protected void hideNotify()
	{
		stopAnimation();
		midlet.display.setCurrent(midlet.mainCanvas);
		midlet.pauseApp();
	}
////---------------------------------------------------------------
////invoked when something that was drawn upon Canvas is removed
////is not invoked if game is resumed by choosing Continue from mainList
////invoked if canvas redrawn after NewStageAlert
	protected void showNotify()
	{
		startAnimation();
	}
}