//filename:SoundsEngine.java

//version for NOK7650_COMM
//version 1.0.0

//Copyright (C) 2003 Zindell Technologies, Ltd.
//All rights reserved. No part of the contents of this program may be
//reproduced or transmitted in any openingForm or by any means without the
//written permission of the publisher.


import com.nokia.mid.sound.*;
import java.io.*;


class NewSound
{
	private Sound[] sound;
	private byte soundBytes[];
	private InputStream tune;
	int num=1;
	
	NewSound(int length) 
	{
		sound = new Sound[length];
		
		for (int i=0; i<length; i++)
		{
			soundBytes = new byte[50000];
			try
			{
				tune = this.getClass().getResourceAsStream("/s"+i+".wav");
				tune.read(soundBytes,0,soundBytes.length);
				sound[i] = new Sound(soundBytes,Sound.FORMAT_WAV);
			}
			catch(OutOfMemoryError out)
			{
				out.printStackTrace();
				sound[i] = null;
				}
			catch(Exception e)
			{
				e.printStackTrace();
				sound[i] = null;
			}
		}
	}
	
	NewSound() 
	{
		this(4);
	}
	
	void playSound(int soundNumber, int repeat)
	{
		stopAll();
		sound[soundNumber].play(repeat);
	}
	
	void playSound(int sndNumber)	
	{
		playSound(sndNumber,1);		
	}
	
	void stopAll()
	{
		for (int j=0; j<sound.length; j++)
		{
			if(sound[j].getState() == Sound.SOUND_PLAYING) sound[j].stop();	
		}
	}	
}
